-module(eNifWorkers).

-include("eHJps.hrl").

-nifs ([
	initMap/1
	, updateMap/3
	, findPath/5
]).

-on_load(init/0).

-export([
	initMap/1
	, updateMap/3
	, findPath/5
]).

init() ->
	case code:priv_dir(?MODULE) of
		{error, _} ->
			case code:which(?MODULE) of
				Filename when is_list(Filename) ->
					SoName = filename:join([filename:dirname(Filename), "../priv", atom_to_list(?MODULE)]);
				_ ->
					SoName = filename:join("../priv", atom_to_list(?MODULE))
			end;
		Dir ->
			SoName = filename:join(Dir, atom_to_list(?MODULE))
	end,
	erlang:load_nif(SoName, 0).

-define(NOT_LOADED, erlang:nif_error({not_loaded, {module, ?MODULE}, {line, ?LINE}})).

initMap(_Data) ->
	?NOT_LOADED.

updateMap(_X, _Y, _NodeInfo) ->
	?NOT_LOADED.

findPath(_StartX, _StartY, _EndX, _EndY, _UpdateInfo) ->
	?NOT_LOADED.


